HDU 1973

Prime Path

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 463    Accepted Submission(s): 305

Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.


Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 
Sample Input
3
1033 8179
1373 8017
1033 1033
 
Sample Output
6
7

0

//这题是求从第一个数字变为第二个数字最少需要变几次,每一次只能改变一个数字,并且要满足改变之后的仍然是素数

//从第一个字符到第四个字符相当于迷宫中的四个方向 接着每次改变从0-9注意开头第一个字符不能以0开头

#include <stdio.h>
#include <string.h>
#include <queue>
using namespace std;
bool vis[9999];  //标记数组
char start[10];  //起始数字用字符串处理
int stop;  //结尾数字
struct Node
{
    char tem[10];
    int step;
};
int prime(int n)  //判断素数
{
    for(int i=2;i*i<=n;i++)
    {
        if(n%i==0)
            return 0;
    }
    return 1;
}

int bfs(char p[])
{
    queue <Node> q;
    memset(vis,0,sizeof(vis));
    int temp;
    Node a;
    strcpy(a.tem,p);
    a.step=0;
    q.push(a);
    while(!q.empty())
    {
        Node b;
        b=q.front();
        q.pop();
        sscanf(b.tem,"%d",&temp);  //利用sscanf函数将字符串转换为数字直接与结尾比较
        if(temp==stop)
            return b.step;
        vis[temp]=1;
        for(int i=0;i<4;i++)
        {
            char k;
            k=i!=0?'0':'1';
            for(;k<='9';k++)
            {
                Node c;
                c=b;
                c.tem[i]=k;
                sscanf(c.tem,"%d",&temp);
                if(prime(temp)&&!vis[temp])  //约束条件
                {
                    c.step++;
                    q.push(c);
                    vis[temp]=1;
                }
            }
        }
    }
    return -1;
}
int main()
{
    int t;
    scanf("%d",&t);
    getchar();
    while(t--)
    {
        scanf("%s%d",start,&stop);
        int flag=bfs(start);
        int flag=bfs(start);
        if(flag==-1)
            printf("Impossible\n");
        else
            printf("%d\n",flag);
    }
    return 0;
}



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值